## vobsub2srt-dmo 1.0~pre7+20171219

=== CMakeLists.txt ===
project(vobsub2srt)

cmake_minimum_required(VERSION 2.6.4 FATAL_ERROR)

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/CMakeModules)

if(NOT CMAKE_BUILD_TYPE)
    set(
        CMAKE_BUILD_TYPE
        Debug
        CACHE
        STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
endif()

message(STATUS "Source: ${CMAKE_SOURCE_DIR}")
message(STATUS "Binary: ${CMAKE_BINARY_DIR}")
message(STATUS "Build type: ${CMAKE_BUILD_TYPE}")

if(${CMAKE_BINARY_DIR} STREQUAL ${CMAKE_SOURCE_DIR})
    message(FATAL_ERROR "In-source builds are not permitted. Make a separate folder for building:\nmkdir build; cd build; cmake ..\nBefore that, remove the files that cmake just created:\nrm -rf CMakeCache.txt CMakeFiles")
endif()

if(BUILD_STATIC)
  message(WARNING "Building a statically linked version of VobSub2SRT is NOT recommended.  You might run into library dependency issues.  Please check the README!")
  set(CMAKE_FIND_LIBRARY_SUFFIXES .a ${CMAKE_FIND_LIBRARY_SUFFIXES})
endif()

set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib)
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin)

set(INSTALL_EXECUTABLES_PATH ${CMAKE_INSTALL_PREFIX}/bin)
set(INSTALL_LIBRARIES_PATH ${CMAKE_INSTALL_PREFIX}/lib)
set(INSTALL_HEADERS_PATH ${CMAKE_INSTALL_PREFIX}/include)
set(INSTALL_ETC_PATH ${CMAKE_INSTALL_PREFIX}/etc)
set(INSTALL_PC_PATH ${CMAKE_INSTALL_PREFIX}/lib/pkgconfig)
set(INSTALL_DATA_DIR_BASE "${CMAKE_INSTALL_PREFIX}/share" CACHE STRING "Custom data installation directory without suffixes")
set(INSTALL_DOC_DIR_BASE "${INSTALL_DATA_DIR_BASE}/doc" CACHE STRING "Custom doc installation directory without suffixes")
set(INSTALL_DOC_DIR "${INSTALL_DOC_DIR_BASE}/${CMAKE_PROJECT_NAME}" CACHE STRING "Custom doc installation directory")
set(INSTALL_MAN_DIR "${INSTALL_DATA_DIR_BASE}/man/man1" CACHE STRING "Custom manpage installation directory without suffixes")

install(FILES "${CMAKE_SOURCE_DIR}/debian/copyright" DESTINATION ${INSTALL_DOC_DIR})
install(FILES "${CMAKE_SOURCE_DIR}/README.org" DESTINATION ${INSTALL_DOC_DIR} RENAME README)

add_definitions("-DINSTALL_PREFIX=\"${CMAKE_INSTALL_PREFIX}\"")

include(CheckIncludeFile)
include(CheckCCompilerFlag)
include(CheckCSourceCompiles)
include(CheckCSourceRuns)
include(CheckCXXCompilerFlag)
include(CheckCXXSourceCompiles)
include(CheckCXXSourceRuns)

set(CMAKE_C_FLAGS "-std=gnu99")
set(CMAKE_CXX_FLAGS "-ansi -pedantic -Wall -Wextra -Wno-long-long")

set(CMAKE_CXX_FLAGS_RELEASE "-O3 -mtune=native -march=native -DNDEBUG -fomit-frame-pointer -ffast-math") # TODO -Ofast GCC 4.6
set(CMAKE_C_FLAGS_RELEASE ${CMAKE_CXX_FLAGS_RELEASE})
set(CMAKE_CXX_FLAGS_DEBUG "-g3 -DDEBUG")
set(CMAKE_C_FLAGS_DEBUG ${CMAKE_CXX_FLAGS_DEBUG})
# TODO RelWithDebInfo MinSizeRel? maybe move -march=native -ffast-math etc. to a different build type

find_package(Threads)
find_package(Tesseract)

add_subdirectory(mplayer)
add_subdirectory(src)
add_subdirectory(doc)

#### Detect Version
if(NOT VOBSUB2SRT_VERSION)
  if(EXISTS "${vobsub2srt_SOURCE_DIR}/version")
    file(READ "${vobsub2srt_SOURCE_DIR}/version" VOBSUB2SRT_VERSION)
    string(REGEX REPLACE "\n" "" VOBSUB2SRT_VERSION "${VOBSUB2SRT_VERSION}")
  elseif(EXISTS "${vobsub2srt_SOURCE_DIR}/.git")
    if(NOT GIT_FOUND)
      find_package(Git QUIET)
    endif()
    if(GIT_FOUND)
      execute_process(
        COMMAND "${GIT_EXECUTABLE}" describe --tags --dirty --always
        WORKING_DIRECTORY "${vobsub2srt_SOURCE_DIR}"
        OUTPUT_VARIABLE VOBSUB2SRT_VERSION
        RESULT_VARIABLE EXECUTE_GIT
        OUTPUT_STRIP_TRAILING_WHITESPACE
        ERROR_QUIET)
      string(REGEX REPLACE "^v" "" VOBSUB2SRT_VERSION "${VOBSUB2SRT_VERSION}")
    endif()
  endif()
endif()

if(NOT VOBSUB2SRT_VERSION)
  set(VOBSUB2SRT_VERSION "unknown-dirty")
endif()

message(STATUS "vobsub2srt version: ${VOBSUB2SRT_VERSION}")

#### uninstall target
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

#### Package Generation
execute_process (
  COMMAND          /usr/bin/dpkg --print-architecture
  OUTPUT_VARIABLE  CPACK_DEBIAN_PACKAGE_ARCHITECTURE
  RESULT_VARIABLE  EXECUTE_RESULT
  OUTPUT_STRIP_TRAILING_WHITESPACE
  ERROR_QUIET
)
if(EXECUTE_RESULT)
  message(STATUS "dpkg not found: No package generation.")
else()
  message(STATUS "Debian architecture: ${CPACK_DEBIAN_PACKAGE_ARCHITECTURE}")
  set(CPACK_GENERATOR "DEB")
  set(CPACK_PACKAGE_NAME "${CMAKE_PROJECT_NAME}")
  set(CPACK_PACKAGE_VERSION "${VOBSUB2SRT_VERSION}")
  set(CPACK_PACKAGE_CONTACT "Rüdiger Sonderfeld <ruediger@c-plusplus.de>")
  set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://github.com/ruediger/VobSub2SRT")
  set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Converts VobSub subtitles (.idx/.srt format) into .srt subtitles.")
  set(CPACK_PACKAGE_DESCRIPTION "VobSub2SRT is a simple command line program to convert .idx / .sub subtitles\ninto .srt text subtitles by using OCR. It is based on code from the MPlayer\nproject - a really great movie player.\nTesseract is used as OCR software.")

  set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/debian/copyright")
  set(CPACK_RESOURCE_FILE_README "${CMAKE_SOURCE_DIR}/README.org")
  set(CPACK_STRIP_FILES TRUE)

  set(CPACK_DEBIAN_PACKAGE_SECTION "video")
  set(CPACK_DEBIAN_PACKAGE_DEPENDS libtesseract-dev)
  set(CPACK_DEBIAN_PACKAGE_BUILD_DEPENDS libavutil-dev libtiff5-dev libtesseract-dev tesseract-ocr-eng cmake pkg-config)
#  set(CPACK_DEBIAN_GIT_DCH TRUE)
  set(CPACK_DEBIAN_UPDATE_CHANGELOG TRUE)
  set(PPA_DEBIAN_VERSION "ppa1")

  include(ppa_config.cmake OPTIONAL)

  set(DPUT_HOST "ppa:ruediger-c-plusplus/vobsub2srt")

  include(CPack)

  if(ENABLE_PPA)
    set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE "any") # can be build on any system
    include(UploadPPA)
  endif()
endif()

=== Makefile ===
.PHONY: all clean distclean install uninstall package dput documentation

all: build
	$(MAKE) -C build

clean: build
	$(MAKE) -C build clean

distclean:
	rm -rf build/

documentation: build
	$(MAKE) -C build documentation

install: build
	$(MAKE) -C build install

uninstall: build
	$(MAKE) -C build uninstall

package: build
	$(MAKE) -C build package

dput:
	@if [ -d build/Debian ]; then \
		git dch --snapshot --since=465fa781b93e66cfb7080c55880969cb4631d584; \
		$(MAKE) -C build dput; \
	else \
		echo 'Use ./configure -DENABLE_PPA=True to activate PPA support.'; \
	fi

build:
	@echo "Please run ./configure (with appropriate parameters)!"
	@exit 1

=== doc/CMakeLists.txt ===
find_program(GZIP gzip
  HINTS
  /bin
  /usr/bin
  /usr/local/bin)

if(GZIP-NOTFOUND)
  message(WARNING "Gzip not found! Uncompressed manpage installed")
  add_custom_target(documentation ALL
    DEPENDS vobsub2srt.1)

  install(FILES vobsub2srt.1 DESTINATION ${INSTALL_MAN_DIR})
else()
  add_custom_command(
    OUTPUT ${CMAKE_BINARY_DIR}/doc/vobsub2srt.1.gz
    COMMAND ${GZIP} -9 -c vobsub2srt.1 > ${CMAKE_BINARY_DIR}/doc/vobsub2srt.1.gz
    MAIN_DEPENDENCY vobsub2srt.1
    WORKING_DIRECTORY "${vobsub2srt_SOURCE_DIR}/doc")

  add_custom_target(documentation ALL
    DEPENDS ${CMAKE_BINARY_DIR}/doc/vobsub2srt.1.gz)

  install(FILES ${CMAKE_BINARY_DIR}/doc/vobsub2srt.1.gz DESTINATION ${INSTALL_MAN_DIR})
endif()

#option(BASH_COMPLETION_PATH "Install the bash completion script to the given path.  Should be set to the value of `pkg-config --variable=completionsdir bash-completion` if available.")

if(NOT BASH_COMPLETION_PATH)
  # Instead of calling pkg-config it should be possible to use
  # find_package(bash-completions).  See the bash-completions README.
  # But Debian/Ubuntu don't ship the cmake configs at the moment.
  # Therefore we fallback to pkg-config.
  find_program(PKG_CONFIG_EXECUTABLE NAMES pkg-config DOC "pkg-config executable")
  mark_as_advanced(PKG_CONFIG_EXECUTABLE)
  if(PKG_CONFIG_EXECUTABLE)
    execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=completionsdir bash-completion
      OUTPUT_VARIABLE BASH_COMPLETION_PATH
      ERROR_QUIET
      OUTPUT_STRIP_TRAILING_WHITESPACE)
  endif()
endif()

if(BASH_COMPLETION_PATH)
  message(STATUS "Bash completion path: ${BASH_COMPLETION_PATH}")
  install(FILES completion.sh DESTINATION ${BASH_COMPLETION_PATH} RENAME vobsub2srt)
else()
  message(STATUS "Bash completions not installed (set -DBASH_COMPLETION_PATH)")
endif()

=== mplayer/CMakeLists.txt ===
add_definitions("-D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE64_SOURCE -D_REENTRANT")
add_definitions("-Wundef -Wall -Wno-switch -Wno-parentheses -Wpointer-arith -Wredundant-decls -Wstrict-prototypes -Wmissing-prototypes -Wdisabled-optimization -Wno-pointer-sign -Wdeclaration-after-statement")

set(mplayer_sources
  mp_msg.c
  mp_msg.h
  spudec.c
  spudec.h
  unrar_exec.c
  unrar_exec.h
  vobsub.c
  vobsub.h
  )

add_library(mplayer STATIC ${mplayer_sources})

=== debian/changelog ===
vobsub2srt-dmo (1.0~pre7+20171219-dmo2) unstable; urgency=medium

  * Add tesseract-ocr-lang and remove tesseract-ocr from Depends.
  * Remove 'Suggests: tesseract-ocr-data'

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 06 Mar 2019 10:09:23 +0100

vobsub2srt-dmo (1.0~pre7+20171219-dmo1) unstable; urgency=medium

  * Git snapshot.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 01 Jul 2018 17:18:31 +0200

vobsub2srt (1.0~pre6+20150323-dmo3) unstable; urgency=medium

  * Rebuild with PIE

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 12 Mar 2017 18:36:30 +0100

vobsub2srt (1.0~pre6+20150323-dmo2) unstable; urgency=medium

  * Build with GCC 5.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 02 Aug 2015 15:27:05 +0200

vobsub2srt (1.0~pre6+20150323-dmo1) unstable; urgency=medium

  * Git snapshot (f5225896).

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 23 Mar 2015 08:57:01 +0100

vobsub2srt (1.0~pre6+1c782e53-dmo2) unstable; urgency=medium

  * Rebuild against libtiff5.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 09 Dec 2013 00:36:31 +0100

vobsub2srt (1.0~pre6+1c782e53-dmo1) unstable; urgency=low

  * Git snapshot.
  * This version add (at least) the --tesseract-lang option (Thanks to
    Krzysztof Bieniasz for the bug report).

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 02 Oct 2013 17:23:30 +0200

vobsub2srt (1.0~pre6-dmo2) unstable; urgency=low

  * Replaces tesseract by tesseract-ocr in Depends (Thanks to Peter Keel)

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 17 Jul 2013 16:28:30 +0200

vobsub2srt (1.0~pre6-dmo1) unstable; urgency=low

  * New upstream release.
  * Replaces tesseract-ocr-dev by libtesseract-dev in Build-Depends.
  * Need to depends on tesseract (Thanks to Zachary Palmer for the bug report).

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 11 Jul 2013 19:15:12 +0200

vobsub2srt (0.0+git20120517-dmo1) unstable; urgency=low

  * Initial release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 17 May 2012 10:15:52 +0200

=== debian/control ===
Source: vobsub2srt-dmo
Section: utils
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://github.com/ruediger/VobSub2SRT/
Standards-Version: 4.3.0
Build-Depends: debhelper-compat (= 12), cmake, libavutil-dev, pkg-config, quilt,
 libtesseract-dev (>= 3.04.01~), bash-completion
 
Package: vobsub2srt
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, tesseract-ocr-lang
Description: convert .idx/.sub subtitles into .srt
 VobSub2SRT is a simple command line program to convert .idx/.sub subtitles
 into .srt text subtitles by using OCR. It is based on code from the
 MPlayer projec. Tesseract is used as OCR software.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with quilt,bash-completion -Scmake -Bbuild

=== debian/watch ===
version=4

##opts="dversionmangle=s/~pre6|-26-g0122ce7|-31-g1c782e5//"


#http://ppa.launchpad.net/ruediger-c-plusplus/vobsub2srt/ubuntu/pool/main/v/vobsub2srt/vobsub2srt_(.*)@ARCHIVE_EXT@
